<template>
  <div class="wraper">
    <span class="box" :style="{transform: `translateY(${boxOffset}px)`}"></span>
    <div class="content" :style="{transform: `translateY(${bodyOffset}px)`}">
      <slot />
    </div>
  </div>
</template>

<script>
export default {
  name: "AnimatedBackgroundBox",
  data() {
    return {
      boxOffset: 0,
      bodyOffset: 0,
      prevScrollY: 0
    }
  },
  methods: {
    upScroll() {
      const up = window.scrollY < this.prevScrollY;
      this.prevScrollY = window.scrollY;
      return up;
    },
    scrollHandler(e) {
      if (this.upScroll()) {
        this.boxOffset += 5;
        this.bodyOffset -= 2;
      } else {
        this.boxOffset -= 5;
        this.bodyOffset += 2;
      }
    }
  },
  mounted() {
    window.addEventListener('scroll', this.scrollHandler);
    this.prevScrollY = window.scrollY;
  },
  beforeDestroy() {
    window.removeEventListener('scroll', this.scrollHandler);
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.wraper
  display flex
  flex-direction row-reverse
  direction ltr

.box
  display block
  min-width 20rem
  background-color rgba($primary, 0.15)
  position relative
  z-index 1
  transition all .1s

.content
  margin $lg -5rem $lg 0
  position relative
  z-index 2
  transition all .1s
</style>